<template>
  <q-btn :color="color" :size="size" @click="descargar" :loading="loading">
    <slot />
  </q-btn>
</template>

<script lang="ts">
import { PropType, defineComponent, ref } from 'vue';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';

export default defineComponent({
  name: 'util-Download',
  props: {
    url: {
      type: String as PropType<string>,
      required: true,
    },
    size: {
      type: String as PropType<string>,
      required: false,
    },
    parametros: {
      type: Object as PropType<object>,
      // eslint-disable-next-line vue/require-valid-default-prop
      default: {},
      required: false,
    },
    color: {
      type: String as PropType<string>,
      required: false,
      default: 'green',
    },

    nombre: {
      type: String as PropType<string>,
      required: false,
      default: null,
    },
  },
  setup(props) {
    const loading = ref(false);

    function descargar() {
      loading.value = true;

      api
        .get(props.url, {
          responseType: 'blob',
          timeout: 1000 * 120, // 2 min
          params: {
            ...props.parametros,
            export: 1,
            rowsPerPag: 999999, // siempre reescribo los registros x pagina, para siempre traer todo
          },
        })
        .then((response: AxiosResponse) => {
          const blob = new Blob([response.data], {
            type: response.headers['content-type'],
          });
          const link = document.createElement('a');
          link.href = URL.createObjectURL(blob);
          if (props.nombre !== null) {
            link.setAttribute('download', props.nombre);
          }
          link.click();
          URL.revokeObjectURL(link.href);
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      descargar,
      loading,
    };
  },
});
</script>
